package jp.agentec.abook.abv.bl.data.tables;

import java.util.ArrayList;
import java.util.List;

import jp.agentec.abook.abv.bl.common.db.SQLiteDatabase;
import jp.agentec.abook.abv.bl.data.DatabaseVersions;

public class TChatMessage extends SQLiteTableScript {

    public TChatMessage() {
    };

    @Override
    public List<String> getCreateScript(int version) {
        List<String> ddl = new ArrayList<String>();
        StringBuffer sql = new StringBuffer();

        sql.append(" create table t_chat_message ( ");
        sql.append("        chat_message_id INTEGER NOT NULL ");
        sql.append("      , chat_room_id INTEGER NOT NULL ");
        sql.append("      , shop_member_id INTEGER NOT NULL ");
        sql.append("      , login_id VARCHAR2 ");
        sql.append("      , message VARCHAR2 ");
        sql.append("      , message_type INTEGER ");
        sql.append("      , image_name VARCHAR2 ");
        sql.append("      , unread_count INTEGER ");
        sql.append("      , download_file_name VARCHAR2 ");
        sql.append("      , save_path VARCHAR2 ");
        sql.append("      , insert_date VARCHAR2(64)");
        sql.append("      , PRIMARY KEY (chat_message_id) ");
        sql.append(" ) ");

        ddl.add(sql.toString());

        return ddl;
    }

    @Override
    public List<String> getUpgradeScript(int oldVersion, int newVersion) {
        List<String> ddl = new ArrayList<String>();
        if (oldVersion < DatabaseVersions.Ver1_3_000) {
            ddl.addAll(getCreateScript(newVersion));
        }
        return ddl;
    }

    @Override
    public List<String> getMigrationScript(SQLiteDatabase databaseConnection, int oldVersion, int newVersion, Object... params) {
        return null;
    }
}
