package jp.agentec.abook.abv.bl.data.tables;

import java.util.ArrayList;
import java.util.List;

import jp.agentec.abook.abv.bl.common.db.SQLiteDatabase;
/**
 * 報告承認情報テーブル（連続作業のみ利用）
 * @author jinsung kim
 * @version　1.2.360
 * @since 2020/10/05
 */
public class TTaskReportApproval extends SQLiteTableScript {
    public TTaskReportApproval() {
        super();
    }

    @Override
    public List<String> getCreateScript(int version) {
        List<String> ddl = new ArrayList<String>();
        StringBuffer sql = new StringBuffer();
        sql.append(" CREATE TABLE t_task_report_approval ( ");
        sql.append("        process_key TEXT NOT NULL ");
        sql.append("      , phase_no SMALLINT DEFAULT 0 ");
        sql.append("      , approval_group_id INTEGER DEFAULT 0 ");
        sql.append("      , approval_group_name TEXT ");
        sql.append("      , approval_name TEXT ");
        sql.append("      , approval_no INTEGER  DEFAULT 0 ");
        sql.append("      , comment TEXT ");
        sql.append("      , sendback_phase_no SMALLINT DEFAULT 0 ");
        sql.append("      , signature TEXT ");
        sql.append("      , status SMALLINT  DEFAULT 0 ");
        sql.append(" ) ");
        ddl.add(sql.toString());
        return ddl;
    }


    @Override
    public List<String> getUpgradeScript(int oldVersion, int newVersion) {
        return null;
    }

    @Override
    public List<String> getMigrationScript(SQLiteDatabase databaseConnection, int oldVersion, int newVersion, Object[] params) {
        return null;
    }
}
